#include <stdio.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define NV_PERIOD 999983
#define STDDEV 0.5
#define RES 300
#define TRIALS 20000
#define MARGIN 0.25

#define RES 50
#define TRIALS 4000

long int nvi = 0, nvd = 1;
double nvs[NV_PERIOD];
#define normalvariate() nvs[(nvi = (nvi + nvd) % NV_PERIOD)]

void init_variates() {
    FILE* fp = fopen("random.dat", "r");
    fread(nvs, sizeof(double), NV_PERIOD, fp);
    fclose(fp);
}

long plucounts[4], appcounts[4], irvcounts[4][4][4], concounts[4][4], borcounts[4];
double ax, ay, bx, by, cx, cy, dx, dy;

long counts[2][2][2][2][2][2][2][2][2][2];
long countranks[2][2][2][2][2][2];
long countapps[2][2][2][2];
long countpairs[4][4];

void clearcounts() {
    memset(counts, 0, sizeof(counts));
    memset(countranks, 0, sizeof(countranks));
    memset(countapps, 0, sizeof(countapps));
    memset(countpairs, 0, sizeof(countpairs));
}

void sumcounts() {
    int aok, bok, cok, dok, ab, ac, ad, bc, bd, cd;
    for (aok = 0; aok < 2; aok++) {
        for (bok = 0; bok < 2; bok++) {
            for (cok = 0; cok < 2; cok++) {
                for (dok = 0; dok < 2; dok++) {
                    for (ab = 0; ab < 2; ab++) {
                        for (ac = 0; ac < 2; ac++) {
                            for (ad = 0; ad < 2; ad++) {
                                for (bc = 0; bc < 2; bc++) {
                                    for (bd = 0; bd < 2; bd++) {
                                        for (cd = 0; cd < 2; cd++) {
int count = counts[aok][bok][cok][dok][ab][ac][ad][bc][bd][cd];
countranks[ab][ac][ad][bc][bd][cd] += count;
countapps[aok][bok][cok][dok] += count;
(ab ? countpairs[0][1] : countpairs[1][0]) += count;
(ac ? countpairs[0][2] : countpairs[2][0]) += count;
(ad ? countpairs[0][3] : countpairs[3][0]) += count;
(bc ? countpairs[1][2] : countpairs[2][1]) += count;
(bd ? countpairs[1][3] : countpairs[3][1]) += count;
(cd ? countpairs[2][3] : countpairs[3][2]) += count;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

int maxwinner(int a, int b, int c, int d) {
    if (a > b && a > c && a > d) return 1;
    if (b > a && b > c && b > d) return 2;
    if (c > a && c > b && c > d) return 4;
    if (d > a && d > b && d > c) return 8;
    return 0;
}

int pluwinner() {
    int va = 0, vb = 0, vc = 0, vd = 0;
    int ab, ac, ad, bc, bd, cd;
    for (ab = 0; ab < 2; ab++) {
        for (ac = 0; ac < 2; ac++) {
            for (ad = 0; ad < 2; ad++) {
                for (bc = 0; bc < 2; bc++) {
                    for (bd = 0; bd < 2; bd++) {
                        for (cd = 0; cd < 2; cd++) {
int count = countranks[ab][ac][ad][bc][bd][cd];
if (ab & ac & ad) va += count;
else if (!ab & bc & bd) vb += count;
else if (!ac & !bc & cd) vc += count;
else if (!ad & !bd & !cd) vd += count;
                        }
                    }
                }
            }
        }
    }
    return maxwinner(va, vb, vc, vd);
}

int appwinner() {
    int va = 0, vb = 0, vc = 0, vd = 0;
    int aok, bok, cok, dok;
    for (aok = 0; aok < 2; aok++) {
        for (bok = 0; bok < 2; bok++) {
            for (cok = 0; cok < 2; cok++) {
                for (dok = 0; dok < 2; dok++) {
int count = countapps[aok][bok][cok][dok];
if (aok) va += count;
if (bok) vb += count;
if (cok) vc += count;
if (dok) vd += count;
                }
            }
        }
    }
    return maxwinner(va, vb, vc, vd);
}

int borwinner() {
    int va = 0, vb = 0, vc = 0, vd = 0;
    int ab, ac, ad, bc, bd, cd;
    for (ab = 0; ab < 2; ab++) {
        for (ac = 0; ac < 2; ac++) {
            for (ad = 0; ad < 2; ad++) {
                for (bc = 0; bc < 2; bc++) {
                    for (bd = 0; bd < 2; bd++) {
                        for (cd = 0; cd < 2; cd++) {
int count = countranks[ab][ac][ad][bc][bd][cd];
va += count * (ab + ac + ad);
vb += count * (!ab + bc + bd);
vc += count * (!ac + !bc + cd);
vd += count * (!ad + !bd + !cd);
                        }
                    }
                }
            }
        }
    }
    return maxwinner(va, vb, vc, vd);
}

int conwinner() {
    int i, j;
    for (i = 0; i < 4; i++) {
        for (j = 0; j < 4; j++) {
            if (countpairs[i][j] < countpairs[j][i]) break;
        }
        if (j == 4) return 1<<i;
    }
    return 0;
}

#define move(loser, d1, d2, d3) { \
    rankings[d1][d2][d3] += rankings[loser][d1][d2] + \
        rankings[d1][loser][d2] + rankings[d1][d2][loser]; \
    rankings[loser][d1][d2] = rankings[d1][loser][d2] = \
        rankings[d1][d2][loser] = 0; \
}

#define sum(a, b, c, d) ( \
    rankings[a][b][c] + rankings[a][b][d] + \
    rankings[a][c][b] + rankings[a][c][d] + \
    rankings[a][d][b] + rankings[a][d][c] )


int irvwinner() {
    int rankings[4][4][4], gt[4][4];
    int ab, ac, ad, bc, bd, cd;
    int a, b, c, d;
    memset(rankings, 0, sizeof(rankings));
    for (ab = 0; ab < 2; ab++) {
        for (ac = 0; ac < 2; ac++) {
            for (ad = 0; ad < 2; ad++) {
                for (bc = 0; bc < 2; bc++) {
                    for (bd = 0; bd < 2; bd++) {
                        for (cd = 0; cd < 2; cd++) {
int count = countranks[ab][ac][ad][bc][bd][cd];
gt[0][1] = ab;
gt[0][2] = ac;
gt[0][3] = ad;
gt[1][0] = !ab;
gt[1][2] = bc;
gt[1][3] = bd;
gt[2][0] = !ac;
gt[2][1] = !bc;
gt[2][3] = cd;
gt[3][0] = !ad;
gt[3][1] = !bd;
gt[3][2] = !cd;
for (a = 0; a < 4; a++) {
    b = (a + 1)%4, c = (a + 2)%4, d = (a + 3)%4;
    if (gt[a][b] & gt[b][c] & gt[c][d]) rankings[a][b][c] += count;
    else if (gt[a][b] & gt[b][d] & gt[d][c]) rankings[a][b][d] += count;
    else if (gt[a][c] & gt[c][b] & gt[b][d]) rankings[a][c][b] += count;
    else if (gt[a][c] & gt[c][d] & gt[d][b]) rankings[a][c][d] += count;
    else if (gt[a][d] & gt[d][b] & gt[b][c]) rankings[a][d][b] += count;
    else if (gt[a][d] & gt[d][c] & gt[c][b]) rankings[a][d][c] += count;
}
                        }
                    }
                }
            }
        }
    }

    int total = sum(0, 1, 2, 3) + sum(1, 2, 3, 0) +
                sum(2, 3, 0, 1) + sum(3, 0, 1, 2);
    int majority = total/2;
    while (1) {
        int va = sum(0, 1, 2, 3);
        int vb = sum(1, 2, 3, 0);
        int vc = sum(2, 3, 0, 1);
        int vd = sum(3, 0, 1, 2);
        if (va >= majority || vb >= majority ||
            vc >= majority || vd >= majority) {
            return maxwinner(va, vb, vc, vd);
        }
        if (va > 0 && (va < vb || vb == 0) &&
            (va < vc || vc == 0) && (va < vd || vd == 0)) {
            move(0,  1, 2, 3);
            move(0,  1, 3, 2);
            move(0,  2, 1, 3);
            move(0,  2, 3, 1);
            move(0,  3, 1, 2);
            move(0,  3, 2, 1);
        } else if (vb > 0 && (vb < va || va == 0) &&
                   (vb < vc || vc == 0) && (vb < vd || vd == 0)) {
            move(1,  0, 2, 3);
            move(1,  0, 3, 2);
            move(1,  2, 0, 3);
            move(1,  2, 3, 0);
            move(1,  3, 0, 2);
            move(1,  3, 2, 0);
        } else if (vc > 0 && (vc < va || va == 0) &&
                   (vc < vb || vb == 0) && (vc < vd || vd == 0)) {
            move(2,  0, 1, 3);
            move(2,  0, 3, 1);
            move(2,  1, 0, 3);
            move(2,  1, 3, 0);
            move(2,  3, 0, 1);
            move(2,  3, 1, 0);
        } else if (vd > 0 && (vd < va || va == 0) &&
                   (vd < vb || vb == 0) && (vd < vc || vc == 0)) {
            move(3,  0, 1, 2);
            move(3,  0, 2, 1);
            move(3,  1, 0, 2);
            move(3,  1, 2, 0);
            move(3,  2, 0, 1);
            move(3,  2, 1, 0);
        } else {
            return maxwinner(va, vb, vc, vd);
        }
    }
}

void count(double x, double y, double t) {
    double ra = (x - ax)*(x - ax) + (y - ay)*(y - ay);
    double rb = (x - bx)*(x - bx) + (y - by)*(y - by);
    double rc = (x - cx)*(x - cx) + (y - cy)*(y - cy);
    double rd = (x - dx)*(x - dx) + (y - dy)*(y - dy);
    int ab = (ra < rb), ac = (ra < rc), ad = (ra < rd);
    int bc = (rb < rc), bd = (rb < rd), cd = (rc < rd);
    double tt = t*t;
    int aok = (ra <= tt);
    int bok = (ra <= tt);
    int cok = (ra <= tt);
    int dok = (ra <= tt);

    counts[aok][bok][cok][dok][ab][ac][ad][bc][bd][cd]++;
}

void runsim(int trials, double x, double y, double stddev) {
    int i;
    for (i = 0; i < trials; i++) {
        double sx = x + normalvariate()*stddev;
        double sy = y + normalvariate()*stddev;
        count(sx, sy, exp(normalvariate())*0.5);
    }
}

int red[15], green[15], blue[15];

void init_colours() {
    int i;
    for (i = 0; i < 16; i++) red[i] = green[i] = blue[i] = 0;
    red[1] = 255;
    red[2] = green[2] = 255;
    green[4] = 255;
    blue[8] = 255;
}

void makemap(double stddev, int res, int trials,
             int axx, int ayy, int bxx, int byy,
             int cxx, int cyy, int dxx, int dyy) {
    int margin = (int) (MARGIN * res);
    int i, j;
    char basename[100], filename[100];
    FILE* pfp;
    FILE* bfp;
    FILE* afp;
    FILE* ifp;
    FILE* cfp;

    ax = axx*0.01;
    ay = ayy*0.01;
    bx = bxx*0.01;
    by = byy*0.01;
    cx = cxx*0.01;
    cy = cyy*0.01;
    dx = dxx*0.01;
    dy = dyy*0.01;

    printf("mapping %02d,%02d %02d,%02d %02d,%02d %02d,%02d\n",
           axx, ayy, bxx, byy, cxx, cyy, dxx, dyy);

    sprintf(basename, "%02d,%02d_%02d,%02d_%02d,%02d_%02d,%02d",
                      axx, ayy, bxx, byy, cxx, cyy, dxx, dyy);

    sprintf(filename, "%s_bor.ppm", basename);
    bfp = fopen(filename, "w");

    sprintf(filename, "%s_plu.ppm", basename);
    pfp = fopen(filename, "w");

    sprintf(filename, "%s_app.ppm", basename);
    afp = fopen(filename, "w");

    sprintf(filename, "%s_irv.ppm", basename);
    ifp = fopen(filename, "w");

    sprintf(filename, "%s_con.ppm", basename);
    cfp = fopen(filename, "w");

    fprintf(pfp, "P6\n%d %d\n255\n", margin*2 + res, margin*2 + res);
    fprintf(afp, "P6\n%d %d\n255\n", margin*2 + res, margin*2 + res);
    fprintf(bfp, "P6\n%d %d\n255\n", margin*2 + res, margin*2 + res);
    fprintf(ifp, "P6\n%d %d\n255\n", margin*2 + res, margin*2 + res);
    fprintf(cfp, "P6\n%d %d\n255\n", margin*2 + res, margin*2 + res);

    for (i = res + margin - 1; i >= -margin; i--) {
        double y = i/(double) res;
        for (j = -margin; j < res + margin; j++) {
            double x = j/(double) res;
            nvi = random() % NV_PERIOD;
            nvd = (random() % (NV_PERIOD - 1)) + 1;

            runsim(trials, x, y, stddev);
            int p = pluwinner();
            fputc(red[p], pfp);
            fputc(green[p], pfp);
            fputc(blue[p], pfp);
            int b = borwinner();
            fputc(red[b], bfp);
            fputc(green[b], bfp);
            fputc(blue[b], bfp);
            int a = appwinner();
            fputc(red[a], afp);
            fputc(green[a], afp);
            fputc(blue[a], afp);
            int i = irvwinner();
            fputc(red[i], ifp);
            fputc(green[i], ifp);
            fputc(blue[i], ifp);
            int c = conwinner();
            fputc(red[c], cfp);
            fputc(green[c], cfp);
            fputc(blue[c], cfp);
        }
        fflush(pfp);
        fflush(afp);
        fflush(bfp);
        fflush(ifp);
        fflush(cfp);
        fputc('.', stdout);
        fflush(stdout);
    }
    fputc('\n', stdout);
    fclose(pfp);
    fclose(afp);
    fclose(bfp);
    fclose(ifp);
    fclose(cfp);
}

#define RC (random() % 100)

int main(int argc, char* argv[]) {
    srandom(0);
    init_variates();
    init_colours();

    if (argc == 1) {
        makemap(STDDEV, RES, TRIALS, 30, 30, 70, 30, 30, 70, 70, 70);
        makemap(STDDEV, RES, TRIALS, 12, 28, 85, 70, 39, 28, 97, 14);
        exit(1);
    }
    if (argc == 2) {
        makemap(STDDEV, RES, TRIALS, 40, 57, 16, 54, 5, 62, 91, 70);
        makemap(STDDEV, RES, TRIALS, 24, 23, 19, 62, 4, 64, 85, 55);
        makemap(STDDEV, RES, TRIALS, 18, 79, 69, 87, 48, 65, 36, 9);
        exit(1);
    }
    if (argc == 3) {
        makemap(STDDEV, RES, TRIALS, 22, 62, 25, 87, 16, 94, 98, 2);
        makemap(STDDEV, RES, TRIALS, 73, 79, 64, 39, 61, 21, 24, 10);
        makemap(STDDEV, RES, TRIALS, 24, 60, 38, 58, 34, 73, 27, 0);
        exit(1);
    }
    if (argc == 4) {
        makemap(STDDEV, RES, TRIALS, 4, 65, 45, 93, 81, 97, 62, 36);
        makemap(STDDEV, RES, TRIALS, 75, 35, 95, 95, 75, 58, 93, 56);
        makemap(STDDEV, RES, TRIALS, 33, 13, 47, 83, 21, 66, 39, 84);
        exit(1);
    }

    srandom(argc);
    while (1) {
        makemap(STDDEV, RES, TRIALS, RC, RC, RC, RC, RC, RC, RC, RC);
    }
}
